#include "php_gtk.h"
#if HAVE_PHP_GTK

#include "gtkscrollpane.h"
#include "ext/gtk+/php_gtk+.h"

void php_scrollpane_register_constants(int module_number TSRMLS_DC)
{


}

PHP_GTK_EXPORT_CE(gtk_scrollpane_ce);

/* object GtkScrollpane  */

PHP_FUNCTION(gtk_scrollpane_new)
{
	zval *Xadjustment, *Yadjustment;
	long aspect_ratio;
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OOi", &Xadjustment, gtk_adjustment_ce, &Yadjustment, gtk_adjustment_ce, &aspect_ratio)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_scrollpane_new(GTK_ADJUSTMENT(PHP_GTK_GET(Xadjustment)), GTK_ADJUSTMENT(PHP_GTK_GET(Yadjustment)), (gint)aspect_ratio);
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkScrollpane object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_scrollpane_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_scrollpane_get_type());
}


PHP_FUNCTION(gtk_scrollpane_goto_edge)
{
	long vertical, horizontal;
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &vertical, &horizontal))
		return;

	php_retval = gtk_scrollpane_goto_edge(GTK_SCROLLPANE(PHP_GTK_GET(this_ptr)), (gint)vertical, (gint)horizontal);
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_scrollpane_step)
{
	long direction;
	zend_bool dowrap;
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &direction, &dowrap))
		return;

	php_retval = gtk_scrollpane_step(GTK_SCROLLPANE(PHP_GTK_GET(this_ptr)), (gint)direction, (gboolean)dowrap);
	RETURN_BOOL(php_retval);
}


static function_entry php_gtk_scrollpane_functions[] = {
	{"GtkScrollpane",	PHP_FN(gtk_scrollpane_new),	NULL},
	{"gtkscrollpane",	PHP_FN(gtk_scrollpane_new),	NULL},
	{"get_type",	PHP_FN(gtk_scrollpane_get_type),	NULL},
	{"goto_edge",	PHP_FN(gtk_scrollpane_goto_edge),	NULL},
	{"step",	PHP_FN(gtk_scrollpane_step),	NULL},
	{NULL, NULL, NULL}
};


void php_scrollpane_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkScrollpane", php_gtk_scrollpane_functions, NULL, NULL, php_gtk_set_property);
	gtk_scrollpane_ce = zend_register_internal_class_ex(&ce, gtk_widget_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkScrollpane"), gtk_scrollpane_ce);


}

#endif /* HAVE_PHP_GTK */
