#include "php_gtk.h"
#if HAVE_PHP_GTK

#include "gtksqpane.h"
#include "ext/gtk+/php_gtk+.h"

void php_sqpane_register_constants(int module_number TSRMLS_DC)
{


}

PHP_GTK_EXPORT_CE(gtk_sqpane_ce);

/* object GtkSQPane  */

PHP_FUNCTION(gtk_sqpane_new)
{
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "")) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_sqpane_new();
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkSQPane object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_sqpane_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_sqpane_get_type());
}


PHP_FUNCTION(gtk_sqpane_add1)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_sqpane_add1(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_add2)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_sqpane_add2(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_add3)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_sqpane_add3(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_add4)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_sqpane_add4(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_pack1)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_sqpane_pack1(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_pack2)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_sqpane_pack2(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_pack3)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_sqpane_pack3(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_pack4)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_sqpane_pack4(GTK_SQPANE(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_set_position)
{
	long x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &x, &y))
		return;

	gtk_sqpane_set_position(GTK_SQPANE(PHP_GTK_GET(this_ptr)), (gint)x, (gint)y);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_set_handle_size)
{
	long size;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &size))
		return;

	gtk_sqpane_set_handle_size(GTK_SQPANE(PHP_GTK_GET(this_ptr)), (guint16)size);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sqpane_compute_position)
{
	long width, height;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &width, &height))
		return;

	gtk_sqpane_compute_position(GTK_SQPANE(PHP_GTK_GET(this_ptr)), (gint)width, (gint)height);
	RETURN_NULL();
}


static function_entry php_gtk_sqpane_functions[] = {
	{"GtkSQPane",	PHP_FN(gtk_sqpane_new),	NULL},
	{"gtksqpane",	PHP_FN(gtk_sqpane_new),	NULL},
	{"get_type",	PHP_FN(gtk_sqpane_get_type),	NULL},
	{"add1",	PHP_FN(gtk_sqpane_add1),	NULL},
	{"add2",	PHP_FN(gtk_sqpane_add2),	NULL},
	{"add3",	PHP_FN(gtk_sqpane_add3),	NULL},
	{"add4",	PHP_FN(gtk_sqpane_add4),	NULL},
	{"pack1",	PHP_FN(gtk_sqpane_pack1),	NULL},
	{"pack2",	PHP_FN(gtk_sqpane_pack2),	NULL},
	{"pack3",	PHP_FN(gtk_sqpane_pack3),	NULL},
	{"pack4",	PHP_FN(gtk_sqpane_pack4),	NULL},
	{"set_position",	PHP_FN(gtk_sqpane_set_position),	NULL},
	{"set_handle_size",	PHP_FN(gtk_sqpane_set_handle_size),	NULL},
	{"compute_position",	PHP_FN(gtk_sqpane_compute_position),	NULL},
	{NULL, NULL, NULL}
};


void php_sqpane_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkSQPane", php_gtk_sqpane_functions, NULL, NULL, php_gtk_set_property);
	gtk_sqpane_ce = zend_register_internal_class_ex(&ce, gtk_container_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkSQPane"), gtk_sqpane_ce);


}

#endif /* HAVE_PHP_GTK */
